#include <LiquidCrystal_I2C.h>
#include <SoftwareSerial.h>

const byte rxPin = 9;
const byte txPin = 8;
const int redLED = 2;
const int greenLED = 3;
const int buzzerPIN = 4;
const int trig = 11;
const int echo = 12;

SoftwareSerial BtSerial(rxPin, txPin);
LiquidCrystal_I2C lcd(0x27, 16, 2);

String messageBuffer = "";
String message = "";
int duration;
int distance;

void setup()
{
  lcd.init();
  lcd.backlight();   
  Serial.begin(9600);
  BtSerial.begin(9600);

  pinMode(redLED, OUTPUT);
  pinMode(greenLED, OUTPUT);
  pinMode(buzzerPIN, OUTPUT);
  pinMode(trig, OUTPUT);
  pinMode(echo, INPUT);
}

void loop()
{
  while (BtSerial.available() > 0) {
    char data = (char) BtSerial.read();
    messageBuffer += data;

    if (data == ';') {
      message = messageBuffer;
      messageBuffer = "";
    }
  }

   digitalWrite(trig, LOW);
   delayMicroseconds(2);
   digitalWrite(trig,HIGH);
   delayMicroseconds(10);
   digitalWrite(trig,LOW);

   duration = pulseIn(echo, HIGH);

   distance = duration * 0.034 / 2;

   Serial.print(distance);
  
   delay(500);

  if(message.indexOf("ON;") >= 0) {

      digitalWrite(greenLED, HIGH);
      noTone(buzzerPIN);

     if(distance <= 10) {
      digitalWrite(redLED, HIGH);
      digitalWrite(greenLED, LOW);
      tone(buzzerPIN, 1000);

      lcd.clear();
      lcd.setCursor(4, 0);
      lcd.print("THERE IS");
      lcd.setCursor(2, 1);
      lcd.print("AN INTRUDER");
    } else {
      digitalWrite(greenLED, HIGH);
      digitalWrite(redLED, LOW);
      noTone(buzzerPIN);

      lcd.clear();
      lcd.setCursor(2, 0);
      lcd.print("THE SECURITY");
      lcd.setCursor(5, 1);
      lcd.print("IS ON");
    }
  }
  
  if(message.indexOf("OFF;") >= 0) {
    digitalWrite(redLED, LOW);
    digitalWrite(greenLED, LOW);
    noTone(buzzerPIN);

    lcd.clear();
    lcd.setCursor(2, 0);
    lcd.print("THE SECURITY");
    lcd.setCursor(5, 1);
    lcd.print("IS OFF");
  }

  delay(500);
}
